#ifndef DBDATACACHE_H
#define DBDATACACHE_H

#include <QHash>
#include <QList>
# include "hdbdata.h"

class DbDataCache
{
    friend class DbThread;

private:

    enum OperationType { Disjoined, ExtendLeft, ExtendRight, None, ExtendLeftRight };

    DbDataCache();

    void invalidate();

    void insert(const QString& attName, const QList<HdbData> &dataList, OperationType operation);

    QList<QDateTime> calculateStartStopDateTime(const QDateTime &start,
                                                const QDateTime &stop,
                                                OperationType &operation);

    void saveStartStopDateTime(const QDateTime& sdat, const QDateTime stodt);

    int maxDataLen() const;

    QHash<QString, QList<HdbData> > mAttDataHash;

    QHash<QString, int> mAttIdHash;

    QDateTime mStartDt, mStopDt;

};

#endif // DBDATACACHE_H
