#ifndef HDBDATAALIGNER_H
#define HDBDATAALIGNER_H

#include "db/hdbdata.h"
#include <QHash>
#include <QString>
#include <QList>

class HdbDataAligner
{
public:
    HdbDataAligner();

    void alignToTimestamps(QHash<QString, QList<HdbData> > &attDataHash,
                           const QDateTime& startDt,
                           const QDateTime &stopDt);

    double getMaximumValue() const { return mMaximum; }

    double getMinimumValue() const { return mMinimum; }

    double getMinimumPositive() const { return mMinimumPositive; }

private:
    double mMaximum, mMinimum, mMinimumPositive;
};

#endif // HDBDATAALIGNER_H
