#include "guihelper.h"
#include <QWidget>
#include <QApplication>
#include <QTabWidget>
#include <QPushButton>

GuiHelper::GuiHelper(QWidget *w)
{
    mWidget = w;
}

void GuiHelper::blockUI(BlockType t)
{
    QList<QWidget *> widgets;
    widgets = mWidget->findChild<QTabWidget *>("tabWidgetConfig")->widget(0)->findChildren<QWidget *>();
    switch(t)
    {
    case LiveMode:
        foreach(QWidget *w, widgets)
            if(w->objectName() != "cbLive" &&
                    w->objectName() != "gbDataSelect" && w->objectName() != "cbAttName" &&
                    w->objectName() != "lCountdown")
                w->setDisabled(true);
        mWidget->findChild<QTabWidget *>("tabWidgetConfig")->widget(0)->findChild<QPushButton *>("pbAbort")->setVisible(true);
        break;

    case GetDataButton:
        qApp->setOverrideCursor(QCursor(Qt::WaitCursor));
        foreach(QWidget *w, widgets)
            if(w->objectName() != "pbAbort")
                w->setDisabled(true);
        mWidget->findChild<QTabWidget *>("tabWidgetConfig")->widget(0)->findChild<QPushButton *>("pbAbort")->setVisible(true);
        break;
    default:
        break;
    }
}

void GuiHelper::unblock()
{
    qApp->restoreOverrideCursor();
    QList<QWidget *> widgets;
    widgets = mWidget->findChild<QTabWidget *>("tabWidgetConfig")->widget(0)->findChildren<QWidget *>();
    foreach(QWidget *w, widgets)
        w->setDisabled(false);
    mWidget->findChild<QTabWidget *>("tabWidgetConfig")->widget(0)->findChild<QPushButton *>("pbAbort")->setVisible(false);
}
