#include "blmhistory.h"
#include <tutil.h>
#include <X11/Xlib.h>
#include <QX11Info>
#include <elettracolors.h>
#include <TApplication>
#include <TSplashScreen>

#define CVSVERSION "$Name:  $"

int main(int argc, char *argv[])
{
    const char *cvs_version = CVSVERSION;
    TApplication a(argc, argv);
    a.setPalette(EPalette("fermi"));
    a.setApplicationName("blmhistory");
    a.setApplicationVersion(cvs_version);
    if(a.arguments().contains("--type=bergoz") || a.arguments().contains("--type=photodiode"))
        a.setPalette(EPalette("elettra"));
    else
        a.setPalette(EPalette("fermi"));
    TUtil::instance()->setLoggingTarget(argv[0]);
    TSplashScreen splash;

    BlmHistory w;
    w.show();

    splash.finish(&w);

    /* register to window manager */
    Display *disp = QX11Info::display();
    Window root_win = (Window) w.winId();
    XSetCommand(disp, root_win, argv, argc);

    return a.exec();
}
