#ifndef PAINTER_H
#define PAINTER_H

class Label;

#define BLM_PIXWIDTH 4
#define IMAGE_W 1440

#include <QtAlgorithms>
#include "imagedata.h"

class Painter
{
public:

    enum DynamicRange { Linear, Logarithmic, NaturalLog, Exponential };

    Painter();

    void createData(Label *image);

    unsigned char *getData() const;

    void setEmptyValue(int value);

    int emptyValue() const { return mEmptyValue; }

    void setDynamicRange(DynamicRange dynamicRange);

    void setMinExpLog(int exp) { mMinExpLog = exp; }

    void setCustomMaxValue(double max) { mCustomMaxValue = max; }

    void setCustomMinValue(double min) { mCustomMinValue = min; }

    void setCustomRangeEnabled(bool en) { mCustomRangeEnabled = en; }

private:
    bool mCustomRangeEnabled;
    ImageData *mData;
    int mEmptyValue, mMinExpLog;
    double mCustomMaxValue, mCustomMinValue;
    DynamicRange mDynamicRange;
};

#endif // PAINTER_H
