#include "blmscalelabel.h"

BlmScaleLabel::BlmScaleLabel()
{
    mLongestString = "sc_thz_mbd.01_upX";
}

QString BlmScaleLabel::label(double value) const
{
    int v = (int) value;
    if(v >= 0 && v < mBlmNames.size())
        return mBlmNames.at(v);
    else
        return "-";
}

void BlmScaleLabel::setBlmDevNames(const QStringList &blmDevNames)
{
    foreach(QString b, blmDevNames)
    {
        QString blm;
        QStringList pts = b.split("/");
        if(pts.size() > 2)
        {
            blm = pts.last();
            blm.remove("blm_");
            mBlmNames << blm;
            if(blm.length() > mLongestString.length())
                mLongestString = blm;
        }
    }
}

QString BlmScaleLabel::longestLabel() const
{
    return mLongestString;
}
