#include "windowssaverestore.h"
#include "blmhistory.h"
#include "ui_blmhistory.h"
#include <QSettings>
#include <QDockWidget>
#include <QtDebug>

WindowsSaveRestore::WindowsSaveRestore()
{

}

void WindowsSaveRestore::save(BlmHistory *w)
{
    QSettings s;
    s.setValue(QString("%1_VISIBLE").arg(w->ui->dockWidgetFixedTime->objectName()),
               w->ui->dockWidgetFixedTime->isVisible());
    if(!w->ui->dockWidgetFixedTime->isHidden())
    {
        s.setValue(QString("%1_FLOATING").arg(w->ui->dockWidgetFixedTime->objectName()),
                   w->ui->dockWidgetFixedTime->isFloating());

        s.setValue(QString("%1_GEOMETRY").arg(w->ui->dockWidgetFixedTime->objectName()),
                   w->ui->dockWidgetFixedTime->geometry());
    }

    s.setValue(QString("%1_VISIBLE").arg(w->ui->dockWidgetSingleBlmTime->objectName()),
               w->ui->dockWidgetSingleBlmTime->isVisible());
    if(!w->ui->dockWidgetSingleBlmTime->isHidden())
    {
        s.setValue(QString("%1_FLOATING").arg(w->ui->dockWidgetSingleBlmTime->objectName()),
                   w->ui->dockWidgetSingleBlmTime->isFloating());
        s.setValue(QString("%1_GEOMETRY").arg(w->ui->dockWidgetSingleBlmTime->objectName()),
                   w->ui->dockWidgetSingleBlmTime->geometry());
    }


    s.setValue(QString("%1_VISIBLE").arg(w->ui->dockWidgetConfiguration->objectName()),
               w->ui->dockWidgetConfiguration->isVisible());
    if(!w->ui->dockWidgetConfiguration->isHidden())
    {
        s.setValue(QString("%1_FLOATING").arg(w->ui->dockWidgetConfiguration->objectName()),
                w->ui->dockWidgetConfiguration->isFloating());
        s.setValue(QString("%1_GEOMETRY").arg(w->ui->dockWidgetConfiguration->objectName()),
                   w->ui->dockWidgetConfiguration->geometry());
    }

    /* main window geometry */
    s.setValue("MAINWIN_GEOMETRY", w->geometry());
}

void WindowsSaveRestore::restore(BlmHistory *w)
{
    QSettings s;
    w->ui->dockWidgetFixedTime->setVisible(s.value(QString("%1_VISIBLE").arg(w->ui->dockWidgetFixedTime->objectName()), true).toBool());
    if(!w->ui->dockWidgetFixedTime->isHidden() && !s.value(QString("%1_GEOMETRY").arg(w->ui->dockWidgetFixedTime->objectName())).isNull())
    {
        w->ui->dockWidgetFixedTime->setGeometry(s.value(QString("%1_GEOMETRY").arg(w->ui->dockWidgetFixedTime->objectName())).toRect());
        w->ui->dockWidgetFixedTime->setFloating(s.value(QString("%1_FLOATING").arg(w->ui->dockWidgetFixedTime->objectName())).toBool());
    }

    w->ui->dockWidgetSingleBlmTime->setVisible(s.value(QString("%1_VISIBLE").arg(w->ui->dockWidgetSingleBlmTime->objectName()), true).toBool());
    if(!w->ui->dockWidgetSingleBlmTime->isHidden() && !s.value(QString("%1_GEOMETRY").arg(w->ui->dockWidgetSingleBlmTime->objectName())).isNull())
    {
        w->ui->dockWidgetSingleBlmTime->setGeometry(s.value(QString("%1_GEOMETRY").arg(w->ui->dockWidgetSingleBlmTime->objectName())).toRect());
        w->ui->dockWidgetSingleBlmTime->setFloating(s.value(QString("%1_FLOATING").arg(w->ui->dockWidgetSingleBlmTime->objectName())).toBool());
    }

    w->ui->dockWidgetConfiguration->setVisible(s.value(QString("%1_VISIBLE").arg(w->ui->dockWidgetConfiguration->objectName()), true).toBool());
    if(!w->ui->dockWidgetConfiguration->isHidden() && !s.value(QString("%1_GEOMETRY").arg(w->ui->dockWidgetConfiguration->objectName())).isNull())
    {
        w->ui->dockWidgetConfiguration->setGeometry(s.value(QString("%1_GEOMETRY").arg(w->ui->dockWidgetConfiguration->objectName())).toRect());
        w->ui->dockWidgetConfiguration->setFloating(s.value(QString("%1_FLOATING").arg(w->ui->dockWidgetConfiguration->objectName())).toBool());

    }

    Ui::MainWindow *ui = w->ui;

    ui->actionBLM_fixed_time_plot->setChecked(!ui->dockWidgetFixedTime->isHidden());
    ui->actionBLM_fixed_BLM_plot->setChecked(!ui->dockWidgetSingleBlmTime->isHidden());
    ui->actionTools_window->setChecked(!ui->dockWidgetConfiguration->isHidden());

    QObject::connect(ui->actionBLM_fixed_time_plot, SIGNAL(triggered(bool)), ui->dockWidgetFixedTime, SLOT(setVisible(bool)));
    QObject::connect(ui->actionBLM_fixed_BLM_plot, SIGNAL(triggered(bool)), ui->dockWidgetSingleBlmTime, SLOT(setVisible(bool)));
    QObject::connect(ui->actionTools_window, SIGNAL(triggered(bool)), ui->dockWidgetConfiguration, SLOT(setVisible(bool)));

    if(s.value("MAINWIN_GEOMETRY").isValid())
        w->setGeometry(s.value("MAINWIN_GEOMETRY").toRect());

}
